<?php
$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
$configfile = '/usr/local/esia/public_html/esia.conf.php';
include_once $configfile;
$rrdpath=RRA_DIRECTORY;
//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}
//on recupère les données
$query= $dbconnection->prepare("SELECT device_id,device_name
				FROM esia_device
				WHERE device_delete=TRUE;");
$ret = $query->execute();
if($ret===false)
{
	$err = $query->errorInfo();
	echo "DB error: ".$err[2]."\n";
	exit(1);
}
//on prépare la requète qui récupére les informations sur la base rrdtool
$q_count = $dbconnection->prepare("SELECT COUNT(*) as nbr FROM esia_services WHERE service_device_id=?");
$q_del = $dbconnection->prepare("DELETE FROM esia_device WHERE device_id=?");
while($row=$query->fetch(PDO::FETCH_OBJ))
{
	$ret = $q_count->execute(array($row->device_id));
	if($ret===false)
	{
		$err = $q_count->errorInfo();
		echo "DB error: ".$err[2]."\n";
		exit(1);
	}
	$nbrservice=$q_count->fetch(PDO::FETCH_OBJ);
	if($nbrservice->nbr==0)
	{
		//suppression des graphiques
        $nodename= preg_replace('#\s#','_',$row->device_name);
        $nodename= preg_replace('#\/#','_',$nodename);
        $nodename= preg_replace('#\\\\#','_',$nodename);
		if(is_dir(RRA_DIRECTORY.$nodename))
		{
			$nodedir=RRA_DIRECTORY.$nodename;
			if($handle = opendir($nodedir))
			{
		 		while(($entry = readdir($handle))!==FALSE)
		 		{
					if($entry !='.' && $entry !='..')
					{
						if(is_file($nodedir.'/'.$entry)===TRUE)
						{
							unlink($nodedir.'/'.$entry);
						}
					}
				}

				closedir($handle);
				rmdir($nodedir);
			}
			else
			{
				echo 'can\'t open dir '.RRA_DIRECTORY.$nodename.'('.$row->device_id.")\n";
			}
		}


		echo 'suppression du noeud '.$row->device_name.'('.$row->device_id.")\n";
		$q_del->execute(array($row->device_id));
	}
}
?>
