<?php

/**
 * @brief Classe définnisant un objet de type Task qui est utilisé par ECATP pour l'execution des threads.
 */

class rrdWorker extends Threaded implements Collectable
{
	/** CONSTANTE
	 *  liste des valeur que peut prendre $status et indique l'état de l'exécution du plugin
	 */

	/** @brief  l'envoit c'est bien passé*/
	const RRD_OK = 0;
	/** @brief  erreur d'initilisation CURL*/
	const RRD_CREATE_ERROR = 1;
	/** @brief  erreur d'initilisation CURL*/
	const RRD_UPDATE_ERROR = 1;

	/** @brief Nom du noeud*/
	private $filename;
	/** @brief la sortie du plugin à traité*/
    private $lastout;
    /** @brief les regexs et les différents paramètre pour la mise à jour du RRD*/
    private $rrd_params;
    /** @brief les différents paramètres de création du RRD*/
    private $rrd_create_option;

    /** @brief les différents paramètres de création du RRD*/
    private $status;
    /** @brief les différents paramètres de création du RRD*/
    private $message;
	/**
	  @brief Constructeur par défaut
	  @param integer $task l'identifiant de la tache.
	  @param string $name le nom du plugin
	  @param string $param les paramètres d'executions
	  @param integer $priorite un priorité de 1 à 7 (default:5)
	  @return void
	 */
	public function __construct($rrd_create_option,$rrd_params)
	{
		$this->rrd_create_option = $rrd_create_option;
        $this->rrd_params = $rrd_params;
        $this->filename = "";
	}
	/**
	 * @brief Destructeur
	 * @detail Destructer, libère les ressource de task et de complete
	 * @return void
	 */
	public function __destruct()
	{

	}
	public function setNodeInformation($filename,$lastout)
	{
        $this->filename = $filename;
        $this->lastout=$lastout;
	}
	/**
	 * @brief méthode d'exécution
	 * @detail la méthode run parmet d'exécuter le plugin demandé et de retournée l'état de la tâche à ecapt
	 */
	public function run( )
	{
	    //on va générer les graphique rrd
        try
        {
	      //  foreach($this->rrd_params as $rows_rrd)
	       // {
		        $filename = $this->rrd_create_option['PATH'].$this->filename;
                $updater = new RRDUpdater($filename);
		        //on execute la regex et on met à jour la base rrd
                $arr = array();
                $log = $this->filename.":";
		        foreach($this->rrd_params as $ds)
		        {
		        	//print_r($ds);
			        $rrdname= $ds['rrd_name'];
                    $com_value='';
                    //echo $this->filename." REGEX: ".$ds['rrd_name']." ".$ds['rrd_regex']." ".$this->lastout."\n";
			        if(preg_match($ds['rrd_regex'],$this->lastout,$regs))
			        {
				        $value = preg_replace('#,#','.',$regs[1]);
                        if(!empty($value))
                        {
				            if(preg_match('#([\*\/\+\-\%])([0-9]*)#',$ds['rrd_calc'],$calc))
				            {
					            switch($calc[1])
					            {
						            case '+': $value=$value+$calc[2];  break;
						            case '-': $value=$value-$calc[2];  break;
						            case '*': $value=$value*$calc[2];  break;
						            case '/': $value=$value/$calc[2];  break;
						            case '%': $value=$value%$calc[2];  break;
						            default: break;
					            }
				            }
				            $com_value= $value;
                        }
                        else
                        {
				            $com_value='U';
                        }
			        }
			        else
			        {
				        $com_value='U';
			        }
                    $arr[$rrdname]=$com_value;
                    $log .= "$rrdname:$com_value:";
		        }
                //print_r($arr);
                $updater->update($arr);
                echo "$log on $filename\n";
	       // }
        }
        catch(Exception $e)
        {
            echo $this->filename.": update error: ".$e->getMessage()."\n";
            exit(1);
        }
    }
}
?>
