#!/usr/bin/php
<?php
$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
$configfile = '/usr/local/esia/public_html/esia.conf.php';
include_once $configfile;
$rrdpath=RRA_DIRECTORY;
//$rrdpath='rra/';
//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
    exit(1);
}
//on prépare la requète qui récupére les informations sur la base rrdtool
$query = $dbconnection->prepare("SELECT rrd_plugin_id,rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_graph_num,rrd_calc FROM rrd_plugins;");
$ret = $query->execute();
if($ret===false)
{
    $err = $query->errorInfo();
    echo "DB error: ".$err[2]."\n";
    exit(0);
}
$arr_rrd_parameter=array();
while($row=$query->fetch(PDO::FETCH_OBJ))
{
    $arr_rrd_parameter[$row->rrd_plugin_id][]=$row;
}
//on recupère les données
$query= $dbconnection->prepare("SELECT DISTINCT service_id,service_name,service_last_stdout,device_name,service_plugin_id,plugin_name
				FROM esia_services
				JOIN esia_device ON device_id = service_device_id
				JOIN esia_plugins ON plugin_id = service_plugin_id
				JOIN rrd_plugins ON rrd_plugin_id=service_plugin_id
				ORDER BY device_name;");
$ret = $query->execute();
if($ret===false)
{
	$err = $query->errorInfo();
	echo "DB error: ".$err[2]."\n";
	exit(0);
}
//$return = exec("cp -R /usr/local/esia/public_html/data/rra/* ./rra",$output,$ret);
$return=true;
$ret=0;
if($return!==false && $ret==0)
{
	$queryinsert= $dbconnection->prepare("INSERT INTO esia_service_rra_file(rra_file_id, rra_service_id,rra_graph_num,rra_file_path)VALUES (DEFAULT,:id,:graph, :path);");
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
	    //on récupère les informations pour le dataSource
        $rows_rrd = $arr_rrd_parameter[$row->service_plugin_id];
	    //liste les information pour générer le graphique et les sépares suivant leurs numéros (clé rrd_graph_num)
	    $list_graphs=array();
	    foreach($rows_rrd as $r)
	    {
		    if(array_key_exists($r->rrd_graph_num,$list_graphs))
		    {
			    array_push($list_graphs[$r->rrd_graph_num],$r);
		    }
		    else
		    {
			    $list_graphs[$r->rrd_graph_num][]=$r;
		    }
	    }
	    //print_r($$list_graphs);
	    //on va générer les graphique rrd
	    $opts=array();
		$opts[] ="DELRRA:0";
		$opts[] ="DELRRA:1";
		$opts[] ="DELRRA:2";
		$opts[] ="DELRRA:3";
		$opts[] ="DELRRA:4";
		$opts[] ="DELRRA:5";
		$opts[] ="DELRRA:6";
		$opts[] ="DELRRA:7";
		$opts[] ="RRA:AVERAGE:0.5:1:432";
		$opts[] ="RRA:AVERAGE:0.5:3:768";
		$opts[] ="RRA:AVERAGE:0.5:9:1024";
		$opts[] ="RRA:AVERAGE:0.5:60:921";
		$opts[] ="RRA:AVERAGE:0.5:96:1098";
		$opts[] ="RRA:MAX:0.5:1:432";
		$opts[] ="RRA:MAX:0.5:3:768";
		$opts[] ="RRA:MAX:0.5:9:1024";
		$opts[] ="RRA:MAX:0.5:60:921";
		$opts[] ="RRA:MAX:0.5:96:1098";
		$opts[] ="RRA:MIN:0.5:1:432";
		$opts[] ="RRA:MIN:0.5:3:768";
		$opts[] ="RRA:MIN:0.5:9:1024";
		$opts[] ="RRA:MIN:0.5:60:921";
		$opts[] ="RRA:MIN:0.5:96:1098";
	    foreach($list_graphs as $rows_rrd)
	    {
	    		try
	    		{
				    //test existence du ficher
		            $nodename= preg_replace('#\s#','_',$row->device_name);
		            $nodename= preg_replace('#\/#','_',$nodename);
		            $nodename= preg_replace('#\\\\#','_',$nodename);
		            $oldfile = $rrdpath.$nodename.'_'.$row->plugin_name.$row->service_id.$rows_rrd[0]->rrd_graph_num.'.rrd';
		            if(file_exists($oldfile)!==FALSE)
		            {
		            	if(!is_dir($rrdpath.$nodename))
		            	{
				        	if (!mkdir($rrdpath.$nodename, 0755, false))
				        	{
								 throw new Exception("Échec lors de la création des dossiers... $rrdpath.$nodename");
							}
						}
						$newfile = $rrdpath.$nodename.'/'.$row->plugin_name.$row->service_id.$rows_rrd[0]->rrd_graph_num.'.rrd';
						//Copy file
						if(copy($oldfile, $newfile))
						{
		            		$ret = rrd_tune($newfile,$opts);
		            		if($ret===false)
		            		{
		            			$err = rrd_error();
		            			 throw new Exception( "tune error: $err");
		            		}
							$queryinsert->execute(array(':id'=>$row->service_id,
														':graph'=>$rows_rrd[0]->rrd_graph_num,
														':path'=>$nodename.'/'.$row->plugin_name.$row->service_id.$rows_rrd[0]->rrd_graph_num.'.rrd'));
						}
						else
						{
						   throw new Exception( "La copie $oldfile du fichier a échoué...");
						}
						unlink($oldfile);
						echo $row->device_name."|".$row->plugin_name."|SUCCESS|MIGRATE\n";
		            }
			}
			catch(Exception $e )
			{
		     	echo $row->device_name."|".$row->plugin_name."|FAILED|".$e->getMessage()."\n";
			}
        }
		if($handle = opendir(RRA_DIRECTORY))
		{
			$now = new DateTime();
			$now = $now->getTimestamp();
	 		while(($entry = readdir($handle))!==FALSE)
	 		{
		    	if($entry !='.' && $entry !='..')
		    	{
					if(is_file(RRA_DIRECTORY.$entry)===TRUE)
					{
						$time = filemtime(RRA_DIRECTORY.$entry);
						$delta = $now - $time;
						if($delta > 2592000)
						{
							echo "suppression du fichier $entry\n";
							unlink(RRA_DIRECTORY.$entry);
						}
					}
		    	}
			}
			closedir($handle);
		}
    }
}
else
{
    echo "erreur copie";
}
?>
