#!/usr/local/gesa/phpcli/bin/php
<?php
//#!/usr/local/gesa/phpcli/bin/php
//#!/root/pollerThread/php/phpcli/bin/php

$options = getopt("DU:");
$ini_conf=array();
$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
$configfile = '/usr/local/esia/public_html/esia.conf.php';
include_once $configfile;
//Chargement fichier de configuration esia
include_once 'libs/EventManager.class.php';
include_once 'libs/rrdWorker.class.php';
include_once 'libs/PoolThread.class.php';
//PARAMETRE DE CREATION DES RRD
$RRD['PATH'] =RRA_DIRECTORY;
$RRD['TIME'] =300;
$RRD['RRA'] = array(
		"AVERAGE:0.5:1:432",
		"AVERAGE:0.5:3:768",
		"AVERAGE:0.5:9:1024",
		"AVERAGE:0.5:60:921",
		"AVERAGE:0.5:96:1098",
		"MAX:0.5:1:432",
		"MAX:0.5:3:768",
		"MAX:0.5:9:1024",
		"MAX:0.5:60:921",
		"MAX:0.5:96:1098",
		"MIN:0.5:1:432",
		"MIN:0.5:3:768",
		"MIN:0.5:9:1024",
		"MIN:0.5:60:921",
		"MIN:0.5:96:1098");

//EVENT MANAGER
if(file_exists('/usr/local/esia/poller/migrate.lock')===TRUE)
{
	echo "mode maintenance\n";
	exit(0);
}
$EVM=new EventManager();

// l'usage des ticks est nécessaire depuis PHP 4.3.0
declare(ticks = 1);

//on vérifie si on est en mode DEBUG
if(isset($options["D"])  || $ini_conf['CORE']['debug'] == 1)
{
	//mode Debug ON
	$EVM->addEventListener(new stdoutLogger(),E_USER_NOTICE);
}
else
{
	//mode Debug OFF
	$EVM->addEventListener(new stdoutLogger(),false);
}
$EVM->notify("Poller Start",E_USER_NOTICE);
try
{
    $EVM->notify("Connexion base de donnée",E_USER_NOTICE);
    //connection à la base de donnée
    try
    {
	    $dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	    $dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
    }
    catch(Exception $e)
    {
	    echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	    echo 'N° : '.$e->getCode();
        exit(1);
    }
    $EVM->notify("Connexion base de donnée SUCCESS",E_USER_NOTICE);
    //on prépare la requète qui récupére les informations sur la base rrdtool
    $query = $dbconnection->prepare("SELECT rrd_plugin_id,rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_graph_num,rrd_calc FROM rrd_plugins ORDER BY rrd_plugin_id,rrd_graph_num;");
    $ret = $query->execute();
    if($ret===false)
    {
        $err = $query->errorInfo();
        echo "DB error: ".$err[2]."\n";
        exit(0);
    }
    //
    $arr_rrd_parameter=array();
    while($row=$query->fetch(PDO::FETCH_ASSOC))
    {
        $plugin_id = $row['rrd_plugin_id'];
        $graph_num = $row['rrd_graph_num'];
        if(array_key_exists($plugin_id,$arr_rrd_parameter))
        {
            if(array_key_exists($graph_num,$arr_rrd_parameter[$plugin_id]))
            {
                array_push($arr_rrd_parameter[$plugin_id][$graph_num],$row);
            }
            else
            {
                $arr_rrd_parameter[$plugin_id][$graph_num][]=$row;
            }
        }
        else
        {
            $arr_rrd_parameter[$plugin_id][$graph_num][]=$row;
        }
    }
    // Création des nouveaux fichiers RRD.
	$query= $dbconnection->prepare("SELECT DISTINCT device_name,service_id,service_name,service_plugin_id,plugin_name
									FROM esia_services
									JOIN esia_device ON device_id = service_device_id
									JOIN esia_plugins ON plugin_id = service_plugin_id
									WHERE service_id NOT IN ( SELECT DISTINCT rra_service_id  FROM esia_service_rra_file)
										AND service_plugin_id IN ( SELECT DISTINCT rrd_plugin_id  FROM rrd_plugins);");
    $ret = $query->execute();
    $queryinsert= $dbconnection->prepare("INSERT INTO esia_service_rra_file(rra_file_id, rra_service_id,rra_graph_num, rra_file_path)VALUES (DEFAULT,:id,:graph, :path);");
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        $nodename= preg_replace('#\s#','_',$row->device_name);
        $nodename= preg_replace('#\/#','_',$nodename);
        $nodename= preg_replace('#\\\\#','_',$nodename);
		if(!is_dir($RRD['PATH'].$nodename))
		{
			if (!mkdir($RRD['PATH'].$nodename, 0755, false))
			{
				$EVM->notify("Failed create folder ".$RRD['PATH']."$nodename",E_USER_ERROR);
			}
		}
		$plugins_rrd = $arr_rrd_parameter[$row->service_plugin_id];
		foreach($plugins_rrd as $rows_rrd)
	    {
	    	//print_r($rows_rrd);
			$filename = $RRD['PATH'].$nodename.'/'.$row->plugin_name.$row->service_id.$rows_rrd[0]['rrd_graph_num'].'.rrd';
			if(file_exists($filename)===FALSE)
			{
				//préparation des paramètres
				$creator = new RRDCreator($filename,0, $rows_rrd[0]['rrd_time']);
				//
				$unknown_point = $RRD['TIME']*2;
				foreach($rows_rrd as $ds)
				{
						    $min='U';
						    $max='U';
						    if($ds['rrd_min']!=-1)
							    $min=$ds['rrd_min'];
						    if($ds['rrd_max']!=-1)
							    $max=$ds['rrd_max'];
		                    $creator->addDataSource($ds['rrd_name'].":".$ds['rrd_type'].":".$unknown_point.":".$min.":".$max);
				}
				foreach($RRD['RRA'] as $line)
		        {
					$creator->addArchive($line);
				}
				$ret = $creator->save();
				if( $ret === FALSE )
				{
					$err = rrd_error();
					$EVM->notify("Create error: $err",E_USER_ERROR);
				}
				$queryinsert->execute(array(':id'=>$row->service_id,
											':graph'=>$rows_rrd[0]['rrd_graph_num'],
											':path'=>$nodename.'/'.$row->plugin_name.$row->service_id.$rows_rrd[0]['rrd_graph_num'].'.rrd'));
			}
			else
			{
				$queryinsert->execute(array(':id'=>$row->service_id,
											':graph'=>$rows_rrd[0]['rrd_graph_num'],
											':path'=>$nodename.'/'.$row->plugin_name.$row->service_id.$rows_rrd[0]['rrd_graph_num'].'.rrd'));
			}
		}
	}
    //Création pool de thread
    $EVM->notify("Création du poller",E_USER_NOTICE);
	$fct = function($rrdWorker )
	{
		//pas moyen de lui passé une propriété de la classe. Donc on fait directement référence à la GLOBAL.
		global $EVM;
		$EVM->notify("ATLAS RESULT device id: ".$workAtlas->notify['device_id']." service: ".$workAtlas->notify['service_name'],E_USER_NOTICE);
		return $rrdWorker->isGarbage();
	};

	$PoolThread = new PoolThread('POLLER',10,PoolThread::AUTOSIZE);
    $EVM->notify("Récupération des données",E_USER_NOTICE);

    //on recupère les données
    $query= $dbconnection->prepare("SELECT DISTINCT service_device_id,service_id,service_plugin_id,service_last_stdout,rra_file_path,rra_graph_num
									FROM esia_services
									JOIN esia_service_rra_file ON service_id = rra_service_id
									ORDER BY service_device_id;");
    $ret = $query->execute();
    if($ret===false)
    {
	    $err = $query->errorInfo();
	    echo "DB error: ".$err[2]."\n";
	    exit(0);
    }
    while($row=$query->fetch(PDO::FETCH_OBJ))
    {
        if(array_key_exists($row->service_plugin_id,$arr_rrd_parameter) ===true )
        {
        	$num = $row->rra_graph_num;
            $rows_rrd = $arr_rrd_parameter[$row->service_plugin_id]["$num"];

           // print_r($rows_rrd);
            $EVM->notify("Création worker ".$row->rra_file_path ,E_USER_NOTICE);
            $rrdWorker = new rrdWorker($RRD,$rows_rrd);
            $rrdWorker->setNodeInformation($row->rra_file_path,$row->service_last_stdout);
            //$rrdWorker->run();
            $PoolThread->submitTask($rrdWorker);
            $EVM->notify("FIN worker ".$row->rra_file_path ,E_USER_NOTICE);
        }
    }
}
catch(Exception $e)
{
    $EVM->notify($e->getMessage(),E_USER_ERROR);
}
